'''
Created on 25. jan. 2012
Activation function factory (class)
@author: Stian
'''

import math
import random
import numpy as np
  

#Activation Functions
def abs_root(value):
    return math.sqrt(math.fabs(value))

def sigmoid(value):
    return math.pow((1.0 + math.exp(-value)), -1.0) 

def si(value):
    return ((1 / (1 + math.exp(-value))) - 0.5) * 2.0
       
def gaussian_rbf(value):
    return math.exp(-math.pow(value, 2.0))

def circle(value):
    return 2*math.pi*value**2
   
def linear_range(value):
    return min(max(value, -3.0),3.0) / 3.0

def linear(value):
    return value % 1

def square(value):
    return value*value

def bool(value):
    return 0 if value <= 0.0 else 1.0

def block(value):
    return 0

def sincos(value):
    return math.sin(value)*math.cos(value)

def sawtooth(value):
    return value-math.floor(value)

def squarewave(value):
    return np.si.sign(np.sin(value))

def d_dv_tanh(v):
    return (4 * np.cosh(v)**2)/(1+np.cosh(2*v))**2

def i_d_dv_tanh(v):
    return -1* (4 * np.cosh(v)**2)/(1+np.cosh(2*v))**2

aFunctions = linear_range, math.sin, math.tanh, gaussian_rbf#math.sin, math.tanh, linear_range, gaussian_rbf, block, bool
#Returns a random function from the list of available activation functions
def get_random_activation_function():
    return random.choice(aFunctions)

if __name__ == '__main__':
    print 
    

