'''
This is an ugly prototype made to rapidly test our problem.
A general implementation of HyperNEAT in Python,
with the right abstractions regarding the EEG-
specific methods is under development 
'''

import cPickle as pickle
from neat import config, population, chromosome, genome, visualize
from neat.nn import nn_pure as nn
import numpy as np
import math
import os
import datetime
import shutil
import cPickle as cp
from scipy.spatial import distance
import neat.ActivationFunctions as AF
from scipy import signal as sig
import matplotlib

#range conversion parameters
d_min = 1.0
d_max = 9.0
o_max = 0.99
o_min = -0.99
d_range = d_max - d_min
o_range = o_max - o_min

#setting up basic geometry
'''
BASIC_GEOMETRY = [  [-0.375595, 0.884846],#AF3
                    [0.375595, 0.884846],#AF4
                    
                    [-0.808524, 0.587427],#F7
                    [0.808524, 0.587427],#F8
                    
                    [-0.545007, 0.673028],#F3
                    [0.545007, 0.673028],#F4
                    
                    [-0.882718, 0.338844],#FC5
                    [0.882718, 0.338844],#FC6
                    
                    [-0.808524, -0.587427],#P7
                    [0.808524, -0.587427],#P8
                    
                    [-0.999391, 0.000000],#T7
                    [0.999391, 0.000000],#T8
                    
                    [-0.308829, -0.950477],#O1
                    [0.308829, -0.950477]]#O2
'''
pos_y = [[np.cos(theta), np. sin(theta)] for theta in np.linspace(0, np.pi, num = 9)][1:8]
neg_y = [[np.cos(theta), np. sin(theta)] for theta in np.linspace(np.pi, 2*np.pi, num = 9)][1:8]
BASIC_GEOMETRY = pos_y + neg_y
HIDDEN_GEOMETRY = BASIC_GEOMETRY

#The EEG channels to use
CHANNELS = [1, 2, 3, 4, 7, 11, 13, 31, 29, 25, 21, 20, 19, 17]

#load testdata
subject = cp.load(open('input dataset folder here', 'rb'))

#Loading config file
config.load('EEG_config')

#Creating a new folder for the experiment, and makes a copy of the current config file
now = datetime.datetime.now()
path = os.getcwd() + "\\results_qvnt\\" + now.strftime("%Y-%m-%d %H%M_%S")
os.makedirs(path)
shutil.copyfile('EEG_config', path +'\\EEG_config')

chromosome.node_gene_type = genome.NodeGene

train = []
test =[]
classes =[]

#setting up ouput geomtery (is this reasonable?)
OUTPUT_GEOMETRY = [[-1.0,1.0],[1.0,-1.0]]

#creating a substrate (ANN)
SUBSTRATE = nn.FeedForward([14*2,14*2,2], False, math.tanh)

#arrays for storing weights computed by the CPPN
weights_input_to_hidden = []
weights_hidden_to_output = []
coords_input_to_hidden= []
coords_hidden_to_output =[]

coords = np.linspace(0.0, 1.0, num=2)
for l in coords:
    for i, inputs_i in enumerate(BASIC_GEOMETRY):
        for k in coords:
            for j, inputs_h in enumerate(HIDDEN_GEOMETRY):
                coords_input_to_hidden.append(inputs_i + [l] +[-1.0] + inputs_h + [k] +[0.0] + [distance.euclidean(inputs_i + [l] +[-1.0], inputs_h + [k] +[0.0])])
                

coords = np.linspace(0.0, 1.0, num=2)
for k in coords:
    for i, inputs_h in enumerate(HIDDEN_GEOMETRY):
        for j, inputs_o in enumerate(OUTPUT_GEOMETRY):
            coords_hidden_to_output.append(inputs_h + [k] + [0.0] + inputs_o + [0.0] + [1.0] + [distance.euclidean(inputs_h +[k] +[0.0], inputs_o + [0.0] +[1.0])])

def convert_value(val, dataset_min, dataset_range, output_min, output_range):
    return (((val - dataset_min) * output_range) / dataset_range) + output_min


#creating time frames
def generate_time_frames(channels, window_length):      
    return [np.reshape(channel, ((channels.shape[1]/window_length), window_length)) for channel in channels]

#Applying FFT to each time frame        
def apply_FFT(channels):
    out=[]
    window = np.hanning(128)
    
    for time_frames in channels: 
        temp=[]       
        for time_frame in time_frames:
            spectrum = np.abs(np.fft.rfft(window*sig.detrend(time_frame)))**2
            spectrum /= (np.abs(window)**2).sum()
            spectrum /= 128.0          
            temp.append(spectrum)
        out.append(temp)
    return np.array(out)

#normalize a 
def normalize(vector, ma):
    return np.array(vector) / ma

def create_examples(data):
    examples = []
    for y in range(data.shape[1]):
        alpha = []
        beta = []
        gamma = []
        theta = []
        
        for x in range(data.shape[0]):
            theta.append(data[x][y][0])
            alpha.append(data[x][y][1])
            beta.append(data[x][y][2])
            gamma.append(data[x][y][3])  
        
        examples.append(np.array(beta + gamma)) 
    return np.array(examples)   
                      
def get_median_band_power(channels):
    out=[] 
    for channel in channels:
        temp = []
        for time_frames in channel:
            temp.append([np.sum(time_frames[3:8]), np.sum(time_frames[8:13]), np.sum(time_frames[13:30]), np.sum(time_frames[30:46])])
        out.append(temp)
    return np.array(out)

#getting specific channels from a set of channels
def get_channels(data, channels, trail_number=0):
    return [data['data'][trail_number][channel] for channel in channels]

def get_labels(data, trail_nr):
    return data['labels'][trail_nr][0:2]

def generate_train_test(subject, trails):
    for i in trails:
        #Get channels from the data according to CHANNELS
        ch = get_channels(subject, CHANNELS, i)
        #Removing baseline for DEAP dataset (3sec)
        ch = [channel[384:]for channel in ch]
        #create time frames
        ch = generate_time_frames(np.array(ch), 128)
        #apply FFT
        ch = apply_FFT(ch)
        #sum band powers ->
        ch = get_median_band_power(ch)
        #create the example cases
        ex = create_examples(ch)
        #calculated the average
        training_data = [np.mean(ex[0:30], 0)]
        test_data = [np.mean(ex[30:], 0)]
        #get classifications
        labels = get_labels(subject, i)
        #convert from [1, 9] -> [-1, 1]
        labels[0] = convert_value(labels[0], d_min, d_range, o_min, o_range)
        labels[1] = convert_value(labels[1], d_min, d_range, o_min, o_range)
        
        #append to list of cases
        train.append(training_data)
        test.append(test_data)
        classes.append(labels)
 
def scale(weight):
    return convert_value(np.abs(weight), 0.2, (1.0-0.2), 0.0, 3.0)
                
            
def scale_or_disable(weight):
    if weight <= -0.2: return -scale(weight)
    elif weight >= 0.2: return scale(weight)
    else: return 0.0 
      
def eval_fitness(population):
    for chromo in population:
        net = nn.create_ffphenotype(chromo)
        s = scale_or_disable
        weights = []
        for coord_pair in coords_input_to_hidden:
            weight = net.sactivate(coord_pair)[0]
            weight = s(weight)
            weights.append(weight)
            
        for coord_pair in coords_hidden_to_output:
            weight = net.sactivate(coord_pair)[1]
            weight = s(weight)
            weights.append(weight)
                             
        SUBSTRATE.update_weights(weights)
        
        error = 0.0
        for i, trails in enumerate(train):
            for example in trails:
                output = SUBSTRATE.sactivate(example)
                error += distance.euclidean(classes[i], output)
        
        chromo.fitness = 1.0/(1.0 + error)

def find_minmax_emo(subject):
    min = 99.0
    min_i = 99
    max = 0.0
    max_i = 99
    for x in range(40):
        labels = get_labels(subject, x)
        sum_v = labels.sum()
        if sum_v  > max :
            max_i = x
            max = sum_v
        elif sum_v  < min :
            min_i = x
            min = sum_v
    
    return [max_i, min_i]

all_subjects = []

#Method for quantitative testing
#outer loop enumerates subject numbers
#inner loop is the number of full runs for the subject   
for sub_i in [9, 10]:
    sub_num = ''
    if sub_i < 10: sub_num = '0'+str(sub_i)
    else: sub_num = str(sub_i)
    subject = cp.load(open('insert dataset folder here'+sub_num+'.dat', 'rb'))
    train = []
    test =[]
    classes = []
    minmax = find_minmax_emo(subject)
    generate_train_test(subject, minmax)
    upper = np.max([test, train])
    train = normalize(train, upper)
    test = normalize(test, upper)
    
    print np.array(train)
    print np.array(test)
    
    run = []
    for i in range(20):
        population.Population.evaluate = eval_fitness
        pop = population.Population()
        pop.epoch(100, report=False, save_best=False, checkpoint_interval=None, save_path=path)
        run.append([pop.stats, pop.species_log])
    
    file = open(path +'\\'+ sub_num, 'w')
    pickle.dump([run, minmax], file)
    file.close()
    
    print np.mean(generalization)    
    all_subjects.append((run, generalization, minmax))
    



# Visualize the winner network (requires PyDot)
#visualize.draw_net(winner) # best chromosome

# Plots the evolution of the best/average fitness (requires Biggles)
#visualize.plot_stats(pop.stats)
# Visualizes speciation
#visualize.plot_species(pop.species_log)


# saves the winner
#file = open(path +'\\winner_chromosome ' + str(winner.fitness), 'w')
#pickle.dump(winner, file)
#file.close()  
   
        
if __name__ == '__main__':

    
